/************************************************************************
 *   IRC - Internet Relay Chat, include/msg.h
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef	__msg_include__
#define __msg_include__

#define MSG_PRIVATE  "PRIVMSG"	/* PRIV */
#define MSGT_PRIVATE "P"
#define MSG_WHO      "WHO"	/* WHO  -> WHOC */
#define MSG_WHOIS    "WHOIS"	/* WHOI */
#define MSG_WHOWAS   "WHOWAS"	/* WHOW */
#define MSG_USER     "USER"	/* USER */
#define MSG_NICK     "NICK"	/* NICK */
#define MSGT_NICK    "N"      
#define MSG_SERVER   "SERVER"	/* SERV */
#define	MSGT_SERVER  "S"	/* SERV */
#define MSG_LIST     "LIST"	/* LIST */
#define MSG_TOPIC    "TOPIC"	/* TOPI */
#define MSGT_TOPIC   "T"
#define MSG_INVITE   "INVITE"	/* INVI */
#define MSG_VERSION  "VERSION"	/* VERS */
#define MSG_QUIT     "QUIT"	/* QUIT */
#define MSGT_QUIT    "Q"
#define MSG_SQUIT    "SQUIT"	/* SQUI */
#define MSG_KILL     "KILL"	/* KILL */
#define	MSGT_KILL    "I"	/* KILL */
#define MSG_INFO     "INFO"	/* INFO */
#define MSG_LINKS    "LINKS"	/* LINK */
#define MSG_STATS    "STATS"	/* STAT */
#define MSG_HELP     "HELP"	/* HELP */
#define MSG_ERROR    "ERROR"	/* ERRO */
#define MSG_AWAY     "AWAY"	/* AWAY */
#define MSGT_AWAY    "A"
#define MSG_CONNECT  "CONNECT"	/* CONN */
#define MSG_UPING    "UPING"    /* UPIN */
#define MSG_MAP      "MAP"      /* MAP  */
#define MSG_PING     "PING"	/* PING */
#define MSG_PONG     "PONG"	/* PONG */
#define MSG_OPER     "OPER"	/* OPER */
#define MSG_HELPER   "HELPER"	/* HELP */
#define MSG_VREMOVER "VREMOVER" /* VREMOVER */
#define MSG_VIRUS    "V"	/* V - virus notice */
#define MSG_PASS     "PASS"	/* PASS */
#define MSG_WALLOPS  "WALLOPS"	/* WALL */
#define	MSGT_WALLOPS "W"	/* WALL */
#define MSG_TIME     "TIME"	/* TIME */
#define MSG_SETTIME  "SETTIME"	/* SETT */
#define	MSGT_SETTIME "E"	/* SETT */
#define MSG_RPING    "RPING"	/* RPIN */
#define MSG_RPONG    "RPONG"	/* RPON */
#define MSG_NAMES    "NAMES"	/* NAME */
#define MSG_ADMIN    "ADMIN"	/* ADMI */
#define MSG_TRACE    "TRACE"	/* TRAC */
#define MSG_NOTICE   "NOTICE"	/* NOTI */
#define	MSG_HISTNOTICE "NO"	/* NOTI */
#define	MSGT_NOTICE  "O"	/* NOTI */
#define MSG_JOIN     "JOIN"	/* JOIN */
#define MSGT_JOIN    "J"
#define MSG_PART     "PART"	/* PART */
#define MSGT_PART    "L"	/* ie, leave */
#define MSG_LUSERS   "LUSERS"	/* LUSE */
#define MSG_MOTD     "MOTD"	/* MOTD */
#define MSG_MODE     "MODE"	/* MODE */
#define MSGT_MODE    "M"    
#define MSG_KICK     "KICK"	/* KICK */
#define MSGT_KICK    "K"
#define MSG_SERVICE  "SERVICE"	/* SERV -> SRVI */
#define MSG_USERHOST "USERHOST"	/* USER -> USRH */
#define MSG_SUSERHOST "SUSERHOST" /*  */
#define MSG_MODNICK  "MODNICK"
#define	MSGT_MODNICK "D"	/*      */
#define MSG_ISON     "ISON"	/* ISON */
#define MSG_SQUERY   "SQUERY"	/* SQUE */
#define MSG_SERVLIST "SERVLIST"	/* SERV -> SLIS */
#define MSG_SERVSET  "SERVSET"	/* SERV -> SSET */
#define	MSG_REHASH   "REHASH"	/* REHA */
#define	MSG_RESTART  "RESTART"	/* REST */
#define	MSG_CLOSE    "CLOSE"	/* CLOS */
#define	MSG_DIE	     "DIE"
#define MSG_PROF     "PROF"
#define	MSG_HASH     "HASH"	/* HASH */
#define	MSG_DNS      "DNS"	/* DNS  -> DNSS */
#define MSG_SILENCE  "SILENCE"  /* SILE */
#define MSG_END_OF_BURST "END_OF_BURST"  /* END_ */
#define	MSG_EOB_ACK  "EOB_ACK"	/* EOB ACK */
#define MSG_KLINE    "KLINE"    /* KLINE */
#define MSG_UNKLINE  "UNKLINE"  /* UNKLINE */
#define MSG_ALINE    "ALINE"    /* ALINE */
#define MSG_GLINE    "GLINE"    /* GLIN */
#define	MSGT_GLINE   "G"	/* GLIN */
#define MSG_GNOTICE  "GNOTICE"  /* GNOTICE */
#define	MSGT_GNOTICE "F"	/* GNOTICE */
#define MSG_GOPER    "GOPER"    /* GOPER */
#define MSG_GLOBOPS  "GLOBOPS"  /* GLOBOPS */
#define	MSGT_GLOBOPS "B"	/* GLOBOPS */
#define MSG_HELPME   "HELPME"   /* HelpOps */
#define MSGT_HELPME  "H"	/* HELPME */
#define MSG_REMOVE   "REMOVE"	/* REMOVE */
#define MSG_ADDCN    "ADDCN"    /* ADD C/N Lines */
#define	MSG_DELCN    "DELCN"	/* DEL C/N Lines */
#define MSG_ADDH     "ADDH"     /* ADD H Lines */
#define	MSG_ADDV     "ADDV"	/* ADD V Lines */
#define	MSG_NOOP     "NOOP"	/* Put server in NOOP Mode */
#define MSG_VWHASH   "VWHASH"	/* New Hash to use for VW */
#ifdef QUOTE_HTM
#define MSG_HTM	     "HTM"	/* HTM */
#endif
#define MAXPARA    15 

extern int m_private(), m_topic(), m_join(), m_part(), m_mode();
extern int m_ping(), m_pong(), m_wallops(), m_kick();
extern int m_nick(), m_error(), m_notice();
extern int m_kline(), m_unkline(), m_remove();
extern int m_addcn(), m_addh(), m_delcn(), m_addv();
#ifdef QUOTE_HTM
extern int m_htm();
#endif
extern int m_gnotice(), m_goper(), m_globops(), m_helpme(); 
extern int m_invite(), m_quit(), m_kill();
extern int m_motd(), m_who(), m_whois(), m_user(), m_list();
extern int m_server(), m_info(), m_links(), m_summon(), m_stats();
extern int m_version(), m_help();
extern int m_squit(), m_away(), m_connect(), m_uping(), m_map();
extern int m_oper(), m_pass(), m_trace();
extern int m_time(), m_settime(), m_rping(), m_rpong(), m_names(), m_admin();
extern int m_lusers(), m_umode(), m_close();
extern int m_motd(), m_whowas(), m_silence();
extern int m_service(), m_userhost(), m_suserhost(), m_ison();
extern int m_service(), m_servset(), m_servlist(), m_squery();
extern int m_gline(), m_aline(), m_end_of_burst(), m_helper();
#if defined(OPER_REHASH) || defined(LOCOP_REHASH)
extern	int	m_rehash();
#endif
#if defined(OPER_RESTART) || defined(LOCOP_RESTART)
extern	int	m_restart();
#endif
#if defined(OPER_DIE) || defined(LOCOP_DIE)
extern	int	m_die();
#endif
#if defined(PROFILE_BUILD)
extern	int	m_prof();
#endif
extern int m_hash(), m_dns(), m_vremover(), m_virus();
extern int m_modnick(), m_wallchops(), m_noop(), m_vwhash();

#ifdef MSGTAB

struct Message msgtab[] = {
  { MSG_PRIVATE,	m_private,	0, MAXPARA, 1 ,0L, 
	"<nick | #channel> <message>",	MSGT_PRIVATE },
  { MSG_NICK,    	m_nick,     	0, MAXPARA, 1 ,0L,
	"<newnick>",			MSGT_NICK },
  { MSG_MODNICK,        m_modnick,      0, MAXPARA, 1, 0L,
        "Restricted to U: lines",       MSGT_MODNICK },
  { MSG_NOTICE,		m_notice,	0, MAXPARA, 1, 0L,
	"<nick | #channel> <message>",	MSGT_NOTICE },
  { MSG_HISTNOTICE,	m_notice,	0, MAXPARA, 1, 0L,
	"Alias for NOTICE",		MSGT_NOTICE },
  { MSG_JOIN,    	m_join,     	0, MAXPARA, 1 ,0L,
	"<#channel>[,<#chan2>,<#chan3>,...]", MSGT_JOIN },
  { MSG_MODE,    	m_mode,     	0, MAXPARA, 1 ,0L,
	"/quote HELP MODE  or  /verbose HELP MODE", MSGT_MODE },
  { MSG_QUIT,    	m_quit,     	0, MAXPARA, 1 ,0L,
	"<reason>",			MSGT_QUIT },
  { MSG_PART,    	m_part,     	0, MAXPARA, 1 ,0L,
	"<#channel>[,<#chan2>,<#chan3>,...] [reason]", MSGT_PART },
  { MSG_TOPIC,   	m_topic,    	0, MAXPARA, 1 ,0L,
	"<#channel> <newtopic>",	MSGT_TOPIC },
  { MSG_INVITE,  	m_invite,   	0, MAXPARA, 1 ,0L,
	"<nickname> <#channel>", 	(char *)NULL },
  { MSG_KICK,    	m_kick,     	0, MAXPARA, 1 ,0L,
	"<#channel> <nickname> <reason>",  MSGT_KICK },
  { MSG_WALLOPS, 	m_wallops,  	0, MAXPARA, 1 ,0L,
	"<message>",			MSGT_WALLOPS },
  { MSG_PING,    	m_ping,     	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_PONG,    	m_pong,     	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_ERROR,   	m_error,    	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_KILL,    	m_kill,     	0, MAXPARA, 1 ,0L,
	"<nickname> <reason>",		MSGT_KILL },
  { MSG_USER,    	m_user,     	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_AWAY,    	m_away,     	0, MAXPARA, 1 ,0L,
	"<reason>",			MSGT_AWAY },
  { MSG_ISON,    	m_ison,     	0, 1,       1 ,0L,
	"<nick1>,<nick2>,<nick3>,...",	(char *)NULL },
  { MSG_SERVER, 	m_server,   	0, MAXPARA, 1 ,0L,
	(char *)NULL,			MSGT_SERVER },
  { MSG_SQUIT,   	m_squit,    	0, MAXPARA, 1 ,0L,
	"<servermask> <reason>", 	(char *)NULL },
  { MSG_WHOIS,   	m_whois,    	0, MAXPARA, 1 ,0L,
	"<nick1>[,<nick2>,<nick3>,...]", (char *)NULL },
  { MSG_WHO,     	m_who,      	0, MAXPARA, 1 ,0L,
	"<mask>    WHO <#channel>     WHO <nickname>", (char *)NULL },
  { MSG_WHOWAS,  	m_whowas,   	0, MAXPARA, 1 ,0L,
	"<nickname>",			(char *)NULL },
  { MSG_LIST,    	m_list,     	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_NAMES,   	m_names,    	0, MAXPARA, 1 ,0L,
	"<#channel>",			(char *)NULL },
  { MSG_USERHOST,	m_userhost, 	0, 1,       1 ,0L,
	"<nickname>",			(char *)NULL },
  { MSG_SUSERHOST,	m_suserhost,	0, 1,       1 ,0L,
	"<nickname>",			(char *)NULL },
  { MSG_TRACE,   	m_trace,    	0, MAXPARA, 1 ,0L,
	"<servermask>     TRACE <nickname>", (char *)NULL },
  { MSG_PASS,    	m_pass,     	0, MAXPARA, 1 ,0L,
	"<password>", 			(char *)NULL },
  { MSG_LUSERS,  	m_lusers,   	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_TIME,    	m_time,     	0, MAXPARA, 1 ,0L,
	"[<servermask>]",		(char *)NULL },
  { MSG_SETTIME, 	m_settime,  	0, MAXPARA, 1 ,0L,
	(char *)NULL,			MSGT_SETTIME },
  { MSG_RPING,   	m_rping,    	0, MAXPARA, 1 ,0L,
	"<servermask> :<current ts>",	(char *)NULL },
  { MSG_RPONG,   	m_rpong,    	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_OPER,    	m_oper,     	0, MAXPARA, 1 ,0L,
	"<nickname> <password>",	(char *)NULL },
  { MSG_HELPER,	 	m_helper,   	0, MAXPARA, 1 ,0L,
	"<nickname> <level>",		(char *)NULL },
  { MSG_CONNECT, 	m_connect,  	0, MAXPARA, 1 ,0L,
	"<servermask> [<port> <ontowhat servermask>]", (char *)NULL },
  { MSG_UPING,   	m_uping,    	0, MAXPARA, 1 ,0L,
	"<servermask> 7007 <number>",	(char *)NULL },
  { MSG_MAP,     	m_map,      	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_VERSION, 	m_version,  	0, MAXPARA, 1 ,0L,
	"[<servermask>]",		(char *)NULL },
  { MSG_STATS,   	m_stats,    	0, MAXPARA, 1 ,0L,
	"<c|d|h|i|k|l|o|t|u|U|w|y|z> [<servermask>]", (char *)NULL },
  { MSG_LINKS,   	m_links,    	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_ADMIN,   	m_admin,    	0, MAXPARA, 1 ,0L,
	"[<servermask>]",		(char *)NULL },
  { MSG_HELP,    	m_help,     	0, MAXPARA, 1 ,0L,
	"[<command>]",			(char *)NULL },
  { MSG_INFO,    	m_info,     	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_MOTD,    	m_motd,     	0, MAXPARA, 1 ,0L,
	"[<servermask>]",		(char *)NULL },
  { MSG_CLOSE,   	m_close,    	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_SILENCE, 	m_silence,  	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_END_OF_BURST,	m_end_of_burst, 0, MAXPARA, 1, 0L,
	(char *)NULL,			(char *)NULL },
#ifdef OPER_KLINE
  { MSG_KLINE,   	m_kline,    	0, MAXPARA, 1 ,0L,
	"<nick | user@host> <reason>",	(char *)NULL },
  { MSG_UNKLINE, 	m_unkline,  	0, MAXPARA, 1 ,0L,
	"<user@host>",			(char *)NULL },
#endif
  { MSG_GLINE,   	m_gline,    	0, MAXPARA, 1 ,0L,
	"Restricted to U: lines",	MSGT_GLINE },
  { MSG_ALINE,		m_aline,	0, MAXPARA, 1 ,0L,
	"Restricted to U: lines",	(char *)NULL },
  { MSG_GNOTICE, 	m_gnotice,  	0, MAXPARA, 1, 0L,
	"Restricted to Servers",	MSGT_GNOTICE },
  { MSG_GOPER,   	m_goper,    	0, MAXPARA, 1, 0L,
	"Restricted to Servers",	(char *)NULL },
  { MSG_GLOBOPS, 	m_globops,  	0, MAXPARA, 1, 0L,
	"<message>",			MSGT_GLOBOPS },
  { MSG_HELPME,  	m_helpme,   	0, MAXPARA, 1, 0L,
	"<message>",			MSGT_HELPME },
/*
  { MSG_REMOVE,  	m_remove,   	0, MAXPARA, 1, 0L,
	"Restricted to U: lines" },
*/
  { MSG_ADDCN,   	m_addcn,    	0, MAXPARA, 1, 0L,
	"Restricted to U: lines",	(char *)NULL },
  { MSG_DELCN,		m_delcn, 	0, MAXPARA, 1, 0L,
	"Restricted to U: lines",	(char *)NULL },
/*
  { MSG_ADDH,    	m_addh,     	0, MAXPARA, 1, 0L,
	"Restricted to U: lines",	(char *)NULL },
*/
  { MSG_ADDV,		m_addv,		0, MAXPARA, 1, 0L,
	"Restricted to U: lines",	(char *)NULL },
  { MSG_NOOP,		m_noop,		0, MAXPARA, 1, 0L,
	"Puts server in NoOper mode",	(char *)NULL },
#ifdef QUOTE_HTM
  { MSG_HTM, 	 	m_htm,	     	0, MAXPARA, 1, 0L,
	"[<on|off|New high k/s>]",	(char *)NULL },
#endif
  { MSG_VWHASH,		m_vwhash,	0, MAXPARA, 1 ,0L,
	"Restricted to U: lines",	(char *)NULL },
  { MSG_HASH,    	m_hash,     	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_DNS,     	m_dns,      	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
  { MSG_VREMOVER,	m_vremover,	0, MAXPARA, 1, 0L,
	(char *)NULL,			(char *)NULL },
  { MSG_VIRUS,		m_virus,	0, MAXPARA, 1, 0L,
	(char *)NULL,			(char *)NULL },
#if defined(OPER_REHASH) || defined(LOCOP_REHASH)
  { MSG_REHASH,  	m_rehash,   	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
#endif
#if defined(OPER_RESTART) || defined(LOCOP_RESTART)
  { MSG_RESTART, 	m_restart,  	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
#endif
#if defined(OPER_DIE) || defined(LOCOP_DIE)
  { MSG_DIE, 		m_die,  	0, MAXPARA, 1 ,0L,
	(char *)NULL,			(char *)NULL },
#endif
#if defined(PROFILE_BUILD)
  { MSG_PROF,		m_prof,		0, MAXPARA, 1, 0L,
	(char *)NULL,			(char *)NULL },
#endif
  { (char *) 0, 	(int (*)()) 0 , 0, 0,       0 ,0L,
	(char *)NULL,			(char *)NULL }
};

#else

extern struct Message msgtab[];

#endif
#endif /* __msg_include__ */
